-- Easy Inventory Search (ALT + Left-Click)
-- TODO: Clear lastSearch on bag close, fix ClearSearchBoxes
-- Sezz: 2012-04-10

local lastSearch = "";
local searchBoxes = {
	"BankItemSearchBox",
	"BagItemSearchBox",
};


local ClearSearchBoxes = function()
	for _, searchBox in pairs(searchBoxes) do
		local searchBoxFrame = _G[searchBox];
		if (searchBoxFrame and searchBoxFrame:GetText() ~= SEARCH) then
			searchBoxFrame:ClearFocus();
			searchBoxFrame:SetText(SEARCH);
		end
	end
end


local InventorySearch = function(itemName)
	ClearSearchBoxes();
	
	if (lastSearch == itemName) then
		itemName = "";
	end
	
	SetItemSearch(itemName);
	lastSearch = itemName;
end


BankFrameItemButtonGeneric_SearchClick = function(self, button)
	if button == "LeftButton" and IsAltKeyDown() and not CursorHasItem() then
		local name = GetItemInfo(GetContainerItemID(BANK_CONTAINER, self:GetID()));
		InventorySearch(name)
	end
end


hooksecurefunc("BankFrameItemButtonGeneric_OnModifiedClick", BankFrameItemButtonGeneric_SearchClick);


-- Most of this code is grennon's from AltClickToAddItem, I just removed the dependancy on AceHooks
-- AltClickToAddItem based on GMail 1.x which was ported from CT_MailMod pre-1.5

local targ, bag, slot


local orig1 = ContainerFrameItemButton_OnModifiedClick
ContainerFrameItemButton_OnModifiedClick = function(self, button, ...)
	if button == "LeftButton" and IsAltKeyDown() and not CursorHasItem() then
		bag, slot = self:GetParent():GetID(), self:GetID()
		if TradeFrame:IsVisible() then
			for i=1,6 do
				if not GetTradePlayerItemLink(i) then
					PickupContainerItem(bag, slot)
					ClickTradeButton(i)
					bag, slot = nil, nil
				return
				end
			  end
		elseif not CursorHasItem() then
			if UnitExists("target") and UnitIsFriend("player", "target") and UnitIsPlayer("target") and CheckInteractDistance("target", 2) then
				targ = UnitName("target")
				InitiateTrade("target")
				return
			elseif BagItemSearchBox:IsVisible() then
				-- Search
				local name = GetItemInfo(GetContainerItemID(bag, slot));
				InventorySearch(name);
			end
		end
	end

	orig1(self, button, ...)
end


local function posthook(...)
	if targ and not CursorHasItem() and UnitName("target") == targ then
		PickupContainerItem(bag, slot)
		ClickTradeButton(1)
	end
	targ, bag, slot = nil, nil, nil

	return ...
end


local orig2 = TradeFrame:GetScript("OnShow")
TradeFrame:SetScript("OnShow", function(...)
	if orig2 then return posthook(orig2(...))
	else posthook() end
end)





