--[[

	Mail Looting
	Martin Karer / Sezz, 2012
	http://sezz.at

	Inspired by MailGet by Jibbs (2008)
	http://wow.curseforge.com/addons/mailget/
	
	------------------------------------------------------------

	README:

		There are no options, it's only a big "Take All" button
		that gets all items or a smaller one to loot a single
		mail. It also remembers the last recipient :)
	
	------------------------------------------------------------

	CHANGELOG:
	
		2012-04-19:
			[:] Mists of Pandaria Support
			[:] Completely rewritten from scratch, because
				CHAT_MSG_LOOT isn't working anymore when
				looting items from mails (bug?).

	------------------------------------------------------------

	[*] Fix  [+] Added [-] Removed  [>] TODO
	[?] WTH? [:] Note  [!] Important/Warning

--]]

-----------------------------------------------------------------------------
-- Single Mail Looting 
-----------------------------------------------------------------------------

local buttonTakeAllSingle = CreateFrame("Button", "OpenMailTakeButton", OpenMailFrame, "UIPanelButtonTemplate");
buttonTakeAllSingle:SetWidth(OpenMailReplyButton:GetWidth());
buttonTakeAllSingle:SetHeight(OpenMailReplyButton:GetHeight());
buttonTakeAllSingle:SetFrameStrata('DIALOG');
buttonTakeAllSingle:SetPoint("right","OpenMailReplyButton","left");
buttonTakeAllSingle:SetText("Take All");

buttonTakeAllSingle.LootMails = function()
	AutoLootMailItem(InboxFrame.openMailID);
end
buttonTakeAllSingle:SetScript("OnClick", buttonTakeAllSingle.LootMails);

-----------------------------------------------------------------------------
-- Fixes 
-----------------------------------------------------------------------------

-- Move "Inbox Full" Warning
InboxTooMuchMail:SetPoint("LEFT", MailFrameTakeAllButton, "RIGHT", 10, 0);

-----------------------------------------------------------------------------
-- Remember Recipient 
-----------------------------------------------------------------------------

local lastRecipient = "";
local saveLastRecipient = function()
	lastRecipient = SendMailNameEditBox:GetText(); 
end

local rememberLastRecipient = function()
	SendMailNameEditBox:SetText(lastRecipient); 
end
	
hooksecurefunc("SendMailFrame_SendMail", saveLastRecipient);
hooksecurefunc("SendMailFrame_Reset", rememberLastRecipient);

-----------------------------------------------------------------------------
-- Take All Loop
-----------------------------------------------------------------------------

-- Create "Take All" Button
local buttonTakeAll = CreateFrame("Button", "MailFrameTakeAllButton", InboxFrame, "UIPanelButtonTemplate");
buttonTakeAll:SetHeight(OpenMailReplyButton:GetHeight());
buttonTakeAll:SetWidth(OpenMailReplyButton:GetWidth() * 1.5);
buttonTakeAll:SetPoint("TOPLEFT", "MailFramePortraitFrame", "RIGHT", 0, -2);
buttonTakeAll:SetText("Take All");
buttonTakeAll:RegisterEvent("MAIL_INBOX_UPDATE");
buttonTakeAll:RegisterEvent("UI_ERROR_MESSAGE");
buttonTakeAll:RegisterEvent("MAIL_CLOSED");

-- Looting
local indexProcessing = 0;
local mailCount = 0;

local lootMailItemNext = function()
	if (indexProcessing == 1) then
		local _, _, _, _, money, _, _, hasItem = GetInboxHeaderInfo(indexProcessing);
		if (money <= 0 and not hasItem) then
			buttonTakeAll:SetScript("OnEvent", nil);
		else
			buttonTakeAll:LootMails()
		end
	else
		buttonTakeAll:LootMails()
	end
end

local lootMailItemInProgress = function(self, event, errorMessage)
	if (event == "MAIL_INBOX_UPDATE") then
		if (GetInboxNumItems() ~= mailCount) then
			lootMailItemNext()
		else
			local _, _, _, _, money, _, _, hasItem = GetInboxHeaderInfo(indexProcessing);
			if (money <= 0 and not hasItem) then
				lootMailItemNext()
			end
		end
	elseif (event == "UI_ERROR_MESSAGE" and errorMessage == ERR_INV_FULL) then
		buttonTakeAll:SetScript("OnEvent", nil);
	elseif (event == "MAIL_CLOSED") then
		buttonTakeAll:SetScript("OnEvent", nil);
	end
end

buttonTakeAll.LootMails = function()
	buttonTakeAll:SetScript("OnEvent", lootMailItemInProgress);
	mailCount = GetInboxNumItems();

	for index = mailCount, 1, -1 do
		local _, _, _, _, money, cod, _, hasItem = GetInboxHeaderInfo(index);
		indexProcessing = index;
		if (cod <= 0 and (money > 0 or hasItem)) then
			AutoLootMailItem(index);
			break;
		end
	end
end

-- Enable "Take All" Button
buttonTakeAll:SetScript("OnClick", buttonTakeAll.LootMails);
